<template>

  <div class="newEducation">
    <div>
      <div class="toolBox">
        <div class="toolOne" @click="startShow = true">
          <div style="display: flex;align-items: center;">
            {{ startTime }}
            <van-icon name="arrow-down" />
          </div>
        </div>
        <div class="toolOne" @click="endShow = true">
          <div style="display: flex;align-items: center;">
            {{ endTime }}
            <van-icon name="arrow-down" />
          </div>
        </div>
      </div>
      <div class="adviceBox" v-if="Education.length > 0">
        <van-list
          v-model="loading"
          :finished="finished"
          finished-text="没有更多了"
          @load="onLoad"
        >
          <div class="adviceMain">
            <div
              class="adviceOne"
              v-for="(item, index) in Education"
              :key="index"
            >
              <div class="adviceTitle">
                <p>{{ getTime(item.assessment_date) }}</p>
                <van-icon
                  class="ellipsis"
                  name="ellipsis"
                  @click="toDeleteEducation(item.id, item.index)"
                />
              </div>
              <div class="statOrder" @click="toEducationDetail(item.id)">
                <div class="orderContent">
                  <p>{{ item.mission }}</p>
                </div>
              </div>
              <div class="all" @click="toEducationDetail(item.id)">全部</div>
            </div>
          </div>
        </van-list>
      </div>

      <div class="noimgBox" v-else>
        <img src="../../../assets/images/none.png" alt />
      </div>
    </div>
    <!-- <div class="add">
      <div style="display: flex;align-items: center;">
        <van-icon class="addIcon" name="add" />新增
      </div>
    </div>-->

    <!-- 弹出层 -->
    <div>
      <van-popup
        class='newPopup'
        get-container="#app"
        v-model="startShow"
        position="bottom"
        :style="{ height: '40%' }"
      >
        <van-datetime-picker
          v-model="currentDate"
          type="date"
          :min-date="minDate"
          :max-date="maxDate"
          @confirm="getstartTime"
          @cancel="startShow = false"
        />
      </van-popup>
      <van-popup v-model="endShow" class='newPopup' get-container="#app" position="bottom" :style="{ height: '40%' }">
        <van-datetime-picker
          v-model="currentDate"
          type="date"
          :min-date="minDate"
          :max-date="maxDate"
          @confirm="getstartTime2"
          @cancel="endShow = false"
        />
      </van-popup>
      <van-action-sheet
        class='newPopup'
        get-container="#app"
        v-model="newShow"
        :actions="actions"
        cancel-text="取消"
        @select="DeleteEducation"
      />
    </div>
  </div>
</template>

<script>
import {
  getNewPatientId,
  getPatientDetail,
  getEducation,
  DeleteEducationOne
} from "@/api/patient/patient";
import { uParseTime } from "@/utils/tools";
import Vue from "vue";
import { Dialog } from "vant";
const moment = require("moment");
export default {
  props: {
    active: Number
  },
  data() {
    return {
      newShow: false,
      startShow: false,
      endShow: false,
      startTime: "请选择",
      endTime: "请选择",
      minDate: new Date(1970, 0, 1),
      maxDate: new Date(2025, 10, 1),
      currentDate: new Date(),
      actions: [{ name: "查看全部" }, { name: "全部删除" }],
      showOne: true,
      showTwo: false,
      limit: 10,
      page: 1,
      total: 0,
      loading: false,
      finished: false,
      list: [],
      Education: [],
      patient_id: "",
      id: 0,
      index: 0,
      date:0,
      patient_name:"",
    };
  },
  methods: {
    onCancel() {
      this.typeShow = false;
    },
    onConfirm(value) {
      this.type = value;
      this.typeShow = false;
    },
    getstartTime(value) {
      this.page = 1;
      let year = value.getFullYear();
      let month = value.getMonth() + 1;
      let day = value.getDate();
      if (month >= 1 && month <= 9) {
        month = `0${month}`;
      }
      if (day >= 1 && day <= 9) {
        day = `0${day}`;
      }

      this.startTime = `${year}-${month}-${day}`;
      this.Education = [];
      this.getEducation(
        this.patient_id,
        this.limit,
        this.page,
        this.startTime,
        this.endTime
      );
      this.startShow = false;
    },
    getstartTime2(value) {
      this.page = 1;
      let year = value.getFullYear();
      let month = value.getMonth() + 1;
      let day = value.getDate();
      if (month >= 1 && month <= 9) {
        month = `0${month}`;
      }
      if (day >= 1 && day <= 9) {
        day = `0${day}`;
      }

      this.endTime = `${year}-${month}-${day}`;
      this.Education = [];
      this.getEducation(
        this.patient_id,
        this.limit,
        this.page,
        this.startTime,
        this.endTime
      );
      this.endShow = false;
    },
    getEducation(id) {
      getEducation(
        id,
        this.limit,
        this.page,
        this.startTime,
        this.endTime
      ).then(response => {
        if (response.data.state === 1) {
          var education = response.data.data.education;
          let arr = this.Education;
          arr.push(...education);
          this.Education = arr;
          var total = response.data.data.total;
          this.total = total;
          this.loading = false;
        }
      });
    },
    onLoad() {
      setTimeout(() => {
        this.page++;
        if (this.page <= Math.ceil(this.total / 10)) {
          this.getEducation(
            this.patient_id,
            this.limit,
            this.page,
            this.startTime,
            this.endTime
          );
        } else {
          this.loading = false;
          this.finished = true;
        }
      }, 3000);
    },
    getPatientDetail(patientid) {
      getPatientDetail(patientid).then(response => {
        if (response.data.state === 1) {
          var patientDetail = response.data.data.patientDetail;
          if (patientDetail.blood_patients == 0) {
            this.Education = [];
            this.showOne = false;
            this.showTwo = true;
          }
          if (patientDetail.blood_patients == 1) {
            this.showOne = true;
            this.showTwo = false;
          }
          this.patientName = patientDetail.name;
        }
      });
    },
    getTime(time) {
      // return uParseTime(time, "{y}-{m}-{d} {h}:{i}:{s}");
      return uParseTime(time, "{y}-{m}-{d}");
    },
    toEducationDetail(id) {
      var patientid = this.$route.query.patient_id;
      this.$router.push(
        "/education?id=" +
          id +
          "&patientid=" +
          patientid +
          "&date="+this.date+"&patient_name="+this.patient_name
      );
    },
    toDeleteEducation(id, index) {
      this.id = id;
      this.index = index;
      this.newShow = true;
    },
    DeleteEducation(value) {
      // console.log("value", value);
      if (value.name == "查看全部") {
        var patientid = this.$route.query.patient_id;
        this.$router.push(
          "/education?id=" +
            this.id +
            "&patientid=" +
            patientid +
            "&date="+this.date+"&patient_name="+this.patient_name
        );
      }
      if (value.name == "全部删除") {
        this.DeleteEducationOne(this.id, this.index);
      }
    },
    DeleteEducationOne(id, index) {
      Dialog.confirm({
        title: "删除提示!",
        message: "确认删除该条信息吗?,删除后将无法恢复!"
      }).then(() => {
        DeleteEducationOne(id).then(response => {
          if (response.data.state === 1) {
            var msg = response.data.data.msg;
            // console.log("msg", msg);
            this.Education.splice(index, 1);
            this.newShow = false;
          }
        });
      });
    },
    getNewPatientId(id){
      getNewPatientId(id).then(response=>{
         if(response.data.state == 1){
          var patient =  response.data.data.patient
          this.getPatientDetail(patient.id);
          this.getEducation(patient.id);
          this.patient_id = patient.id;
         }
      })
    }
  },
  created() {
    var patientid = this.$route.query.patient_id;
    this.getNewPatientId(patientid)
    this.date =  this.$route.query.date
    this.patient_name =  this.$route.query.patient_name
  }
};
</script>

<style lang="scss" scoped>
.newEducation {
  height: 100%;
  overflow-y: auto;
  background: #fff;
  padding-top:2.75rem;
  .toolBox {
    display: flex;
    height: 3.125rem;
    justify-content: space-around;
    align-items: center;
    .toolOne {
      width: 6.25rem;
      height: 1.875rem;
      background: rgba(246, 246, 246, 1);
      border-radius: 5px;
      text-align: center;
      font-size: 0.8125rem;
      color: #8d8d8d;
      display: flex;
      align-items: center;
      justify-content: space-around;
    }
  }
  .adviceBox {
    padding: 0 1.125rem;
    margin-bottom: 3.125rem;
  }
  .adviceOne {
    box-shadow: 0px 1px 0px 0px rgba(0, 0, 0, 0.1);
    padding-bottom: 0.625rem;
  }
  .adviceTitle {
    padding-top: 0.625rem;
    display: flex;
    align-items: center;
    justify-content: space-between;
    p {
      color: #000000;
      font-weight: bold;
      font-size: 0.9375rem;
    }
  }
  .ellipsis {
    font-size: 1.25rem;
    color: #cccccc;
  }
  .statOrderTitle {
    color: #5b98ff;
    font-size: 0.8125rem;
    font-weight: bold;
    margin: 0.625rem 0;
  }
  .longOrderTitle {
    color: #ff964a;
    font-size: 0.8125rem;
    font-weight: bold;
    margin: 0.625rem 0;
  }
  .orderContent {
    font-size: 0.875rem;
    color: rgba(49, 50, 52, 1);
    margin-top: .625rem;
    p {
      line-height: 1.125rem;
    }
  }
  .doctorBox {
    font-size: 0.75rem;
    color: rgba(152, 152, 152, 1);
    line-height: 1.125rem;
    display: flex;
    align-items: center;
    justify-content: space-between;
    margin-top: 0.625rem;
  }
  .all {
    font-size: 0.8125rem;
    color: #5b98ff;
    margin-top: 0.625rem;
  }
  .noimgBox {
    margin-top: 40%;
    img {
      width: 9.375rem;
      height: 9.375rem;
      margin: 0 auto;
      display: block;
    }
  }
  // .add {
  //   position: fixed;
  //   bottom: 0;
  //   left: 0;
  //   width: 100%;
  //   height: 2.75rem;
  //   background: rgba(255, 255, 255, 1);
  //   box-shadow: 0px -1px 0px 0px rgba(0, 0, 0, 0.1);
  //   display: flex;
  //   align-items: center;
  //   justify-content: space-around;
  //   font-size: 0.9375rem;
  //   color: #979798;
  //   .addIcon {
  //     color: #5b98ff;
  //     font-size: 1.25rem;
  //     margin-right: 0.25rem;
  //   }
  // }
  .van-popup {
    border-radius: 0;
    transform: translate3d(0, 0, 0);
    top: initial;
  }
}
::-webkit-scrollbar {
  width: 0;
}
</style>

